PingOne Platform APIs - Early Access

Create Variable Declaration

 

POST {{apiPath}}/environments/{{envID}}/promotionVariableDeclarations

Use the POST {{apiPath}}/environments/{{envID}}/promotionVariableDeclarations request to declare (assign a value to) a promotion variable for use in the specified environment. You must first have defined the promotion variable using the Create Variable Definition request.

When creating or updating promotion variable declarations, if the bound resource attribute is classified as sensitive (such as for client secrets or passwords), the associated variable definition in the target environment must also be marked as sensitive (the isSensitive attribute set to true). If it is not, the request fails with a validation error.
Request Model
Property Type Required?

resourceId

String

Required

variables

Map

Required

Headers

Authorization      Bearer {{accessToken}}

Content-Type      application/json

Body

raw ( application/json )

{
    "resource": {"id": "d8e643d9-105b-4f59-82f0-e549a34ee0c0"},
    "variables": {"sloEndpoint": "${promotionVariable: sloEndpointVar}"}
}

Example Request

  • cURL

  • C#

  • Go

  • HTTP

  • Java

  • jQuery

  • NodeJS

  • Python

  • PHP

  • Ruby

  • Swift

curl --location --globoff '{{apiPath}}/environments/{{envID}}/promotionVariableDeclarations' \
--header 'Content-Type: application/json' \
--header 'Authorization: Bearer {{accessToken}}' \
--data '{
    "resource": {"id": "d8e643d9-105b-4f59-82f0-e549a34ee0c0"},
    "variables": {"sloEndpoint": "${promotionVariable: sloEndpointVar}"}
}'
var options = new RestClientOptions("{{apiPath}}/environments/{{envID}}/promotionVariableDeclarations")
{
  MaxTimeout = -1,
};
var client = new RestClient(options);
var request = new RestRequest("", Method.Post);
request.AddHeader("Content-Type", "application/json");
request.AddHeader("Authorization", "Bearer {{accessToken}}");
var body = @"{" + "\n" +
@"    ""resource"": {""id"": ""d8e643d9-105b-4f59-82f0-e549a34ee0c0""}," + "\n" +
@"    ""variables"": {""sloEndpoint"": ""${promotionVariable: sloEndpointVar}""}" + "\n" +
@"}";
request.AddStringBody(body, DataFormat.Json);
RestResponse response = await client.ExecuteAsync(request);
Console.WriteLine(response.Content);
package main

import (
  "fmt"
  "strings"
  "net/http"
  "io"
)

func main() {

  url := "{{apiPath}}/environments/{{envID}}/promotionVariableDeclarations"
  method := "POST"

  payload := strings.NewReader(`{
    "resource": {"id": "d8e643d9-105b-4f59-82f0-e549a34ee0c0"},
    "variables": {"sloEndpoint": "${promotionVariable: sloEndpointVar}"}
}`)

  client := &http.Client {
  }
  req, err := http.NewRequest(method, url, payload)

  if err != nil {
    fmt.Println(err)
    return
  }
  req.Header.Add("Content-Type", "application/json")
  req.Header.Add("Authorization", "Bearer {{accessToken}}")

  res, err := client.Do(req)
  if err != nil {
    fmt.Println(err)
    return
  }
  defer res.Body.Close()

  body, err := io.ReadAll(res.Body)
  if err != nil {
    fmt.Println(err)
    return
  }
  fmt.Println(string(body))
}
POST /environments/{{envID}}/promotionVariableDeclarations HTTP/1.1
Host: {{apiPath}}
Content-Type: application/json
Authorization: Bearer {{accessToken}}

{
    "resource": {"id": "d8e643d9-105b-4f59-82f0-e549a34ee0c0"},
    "variables": {"sloEndpoint": "${promotionVariable: sloEndpointVar}"}
}
OkHttpClient client = new OkHttpClient().newBuilder()
  .build();
MediaType mediaType = MediaType.parse("application/json");
RequestBody body = RequestBody.create(mediaType, "{\n    \"resource\": {\"id\": \"d8e643d9-105b-4f59-82f0-e549a34ee0c0\"},\n    \"variables\": {\"sloEndpoint\": \"${promotionVariable: sloEndpointVar}\"}\n}");
Request request = new Request.Builder()
  .url("{{apiPath}}/environments/{{envID}}/promotionVariableDeclarations")
  .method("POST", body)
  .addHeader("Content-Type", "application/json")
  .addHeader("Authorization", "Bearer {{accessToken}}")
  .build();
Response response = client.newCall(request).execute();
var settings = {
  "url": "{{apiPath}}/environments/{{envID}}/promotionVariableDeclarations",
  "method": "POST",
  "timeout": 0,
  "headers": {
    "Content-Type": "application/json",
    "Authorization": "Bearer {{accessToken}}"
  },
  "data": JSON.stringify({
    "resource": {
      "id": "d8e643d9-105b-4f59-82f0-e549a34ee0c0"
    },
    "variables": {
      "sloEndpoint": "${promotionVariable: sloEndpointVar}"
    }
  }),
};

$.ajax(settings).done(function (response) {
  console.log(response);
});
var request = require('request');
var options = {
  'method': 'POST',
  'url': '{{apiPath}}/environments/{{envID}}/promotionVariableDeclarations',
  'headers': {
    'Content-Type': 'application/json',
    'Authorization': 'Bearer {{accessToken}}'
  },
  body: JSON.stringify({
    "resource": {
      "id": "d8e643d9-105b-4f59-82f0-e549a34ee0c0"
    },
    "variables": {
      "sloEndpoint": "${promotionVariable: sloEndpointVar}"
    }
  })

};
request(options, function (error, response) {
  if (error) throw new Error(error);
  console.log(response.body);
});
import requests
import json

url = "{{apiPath}}/environments/{{envID}}/promotionVariableDeclarations"

payload = json.dumps({
  "resource": {
    "id": "d8e643d9-105b-4f59-82f0-e549a34ee0c0"
  },
  "variables": {
    "sloEndpoint": "${promotionVariable: sloEndpointVar}"
  }
})
headers = {
  'Content-Type': 'application/json',
  'Authorization': 'Bearer {{accessToken}}'
}

response = requests.request("POST", url, headers=headers, data=payload)

print(response.text)
<?php
require_once 'HTTP/Request2.php';
$request = new HTTP_Request2();
$request->setUrl('{{apiPath}}/environments/{{envID}}/promotionVariableDeclarations');
$request->setMethod(HTTP_Request2::METHOD_POST);
$request->setConfig(array(
  'follow_redirects' => TRUE
));
$request->setHeader(array(
  'Content-Type' => 'application/json',
  'Authorization' => 'Bearer {{accessToken}}'
));
$request->setBody('{\n    "resource": {"id": "d8e643d9-105b-4f59-82f0-e549a34ee0c0"},\n    "variables": {"sloEndpoint": "${promotionVariable: sloEndpointVar}"}\n}');
try {
  $response = $request->send();
  if ($response->getStatus() == 200) {
    echo $response->getBody();
  }
  else {
    echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' .
    $response->getReasonPhrase();
  }
}
catch(HTTP_Request2_Exception $e) {
  echo 'Error: ' . $e->getMessage();
}
require "uri"
require "json"
require "net/http"

url = URI("{{apiPath}}/environments/{{envID}}/promotionVariableDeclarations")

http = Net::HTTP.new(url.host, url.port);
request = Net::HTTP::Post.new(url)
request["Content-Type"] = "application/json"
request["Authorization"] = "Bearer {{accessToken}}"
request.body = JSON.dump({
  "resource": {
    "id": "d8e643d9-105b-4f59-82f0-e549a34ee0c0"
  },
  "variables": {
    "sloEndpoint": "\${promotionVariable: sloEndpointVar}"
  }
})

response = http.request(request)
puts response.read_body
let parameters = "{\n    \"resource\": {\"id\": \"d8e643d9-105b-4f59-82f0-e549a34ee0c0\"},\n    \"variables\": {\"sloEndpoint\": \"${promotionVariable: sloEndpointVar}\"}\n}"
let postData = parameters.data(using: .utf8)

var request = URLRequest(url: URL(string: "{{apiPath}}/environments/{{envID}}/promotionVariableDeclarations")!,timeoutInterval: Double.infinity)
request.addValue("application/json", forHTTPHeaderField: "Content-Type")
request.addValue("Bearer {{accessToken}}", forHTTPHeaderField: "Authorization")

request.httpMethod = "POST"
request.httpBody = postData

let task = URLSession.shared.dataTask(with: request) { data, response, error in
  guard let data = data else {
    print(String(describing: error))
    return
  }
  print(String(data: data, encoding: .utf8)!)
}

task.resume()

Example Response

201 Created

{
    "_links": {
        "self": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/promotionVariableDeclarations/d8e643d9-105b-4f59-82f0-e549a34ee0c0"
        },
        "environment": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
        }
    },
    "environment": {
        "id": "abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
    },
    "resource": {
        "id": "d8e643d9-105b-4f59-82f0-e549a34ee0c0"
    },
    "variables": {
        "sloEndpoint": "${promotionVariable: sloEndpointVar}"
    },
    "createdAt": "2024-09-09T17:37:23.136Z",
    "updatedAt": "2024-09-09T17:37:23.136Z"
}